/*
 * embuttons.js
 */

var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

// Replace openExtensions: Tools menu items will honour the EMbuttons settings

openExtensions = embuttonsOpenExtensions;

function embuttonsOpenExtensions(aOpenMode)
{
   const EMTYPE = "Extension:Manager";
   const EMFEATURES = "chrome,dialog=no,resizable";
   const EMURL = "chrome://mozapps/content/extensions/extensions.xul?type=" + aOpenMode;

   try {
      var sortPref = (gPref.getBoolPref("extensions.embuttons.alphasortEM"));
   } catch(e){}

   var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
   var needToOpen = true;
   var windowType = EMTYPE + "-" + aOpenMode;
   var windows = wm.getEnumerator(windowType);
   while (windows.hasMoreElements()) {
      var theEM = windows.getNext().QueryInterface(Components.interfaces.nsIDOMWindowInternal);
      if (theEM.document.documentElement.getAttribute("windowtype") == windowType) {
         theEM.focus();
         needToOpen = false;
         break;
      }
   }

   if (needToOpen) {
      if (sortPref) SortExtensionsBy('name',(aOpenMode == 'extensions') ? 'extension' : 'theme');
         window.openDialog(EMURL, "", EMFEATURES);
   }

}


function SortExtensionsBy(aProp,aType)
{
   var whichRoot = "urn:mozilla:" + aType + ":root"
   var sortTarget=function(aResource,aSortProperty)
   {
      this.resource=aResource;
      this.prop=aSortProperty;
      this.toString=function(){return this.prop;};
   };

   var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
               .getService(Components.interfaces.nsIRDFService);
   var Container = Components.classes["@mozilla.org/rdf/container;1"]
               .getService(Components.interfaces.nsIRDFContainer);

   var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
      .getService(Components.interfaces.nsIExtensionManager).datasource;
   var root=RDFService.GetResource(whichRoot);
   var arc=RDFService.GetResource("http://www.mozilla.org/2004/em-rdf#"+aProp);
   Container.Init(extensionDS,root);

   var elements=Container.GetElements();
   var sortArray=[];
   try{
      while(elements.hasMoreElements())
      {
         var element=elements.getNext();
         var prop="";
         element.QueryInterface(Components.interfaces.nsIRDFResource);
         var target=extensionDS.GetTarget(element, arc ,true);
         if(target)
            prop=target
               .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
         sortArray.push(new sortTarget(element,prop));
         Container.RemoveElement(element,false);
      }
   }catch(e){}
   sortArray.sort();
   for(var i in sortArray)
      Container.AppendElement(sortArray[i].resource)

   extensionDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
   extensionDS.Flush();
}


